summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2000-12-03 20:46:07 +0000
committerJim Meyering <jim@meyering.net>2000-12-03 20:46:07 +0000
commit82a6fbda1cf17c680559f94da7d32397836abfa8 (patch)
tree2d82010f4023666da215cf71452a31cc7e1532d1
parent177b2553e2cfaea10c7968c776d833ef78ee474b (diff)
downloadcoreutils-82a6fbda1cf17c680559f94da7d32397836abfa8.tar.xz
*** empty log message ***
-rw-r--r--old/textutils/ChangeLog2
-rwxr-xr-xtests/tail-2/assert-246
2 files changed, 48 insertions, 0 deletions
diff --git a/old/textutils/ChangeLog b/old/textutils/ChangeLog
index 938f0d6ed..6c434b919 100644
--- a/old/textutils/ChangeLog
+++ b/old/textutils/ChangeLog
@@ -3,6 +3,8 @@
* src/tail.c (tail_file): Initialize ignore, dev, and ino members,
when tailing forever and the open failed. Otherwise, we could get
uninitialized memory references of those fields in recheck.
+ * tests/tail-2/Makefile.am (TESTS): Add assert-2.
+ * tests/tail-2/assert-2: New file.
* Version 2.0.9.
diff --git a/tests/tail-2/assert-2 b/tests/tail-2/assert-2
new file mode 100755
index 000000000..c036e2619
--- /dev/null
+++ b/tests/tail-2/assert-2
@@ -0,0 +1,46 @@
+#!/bin/sh
+# This variant of `assert' would get a UMR reliably in 2.0.9.
+# Due to a race condition in the test, the `assert' script would get
+# the UMR on Solaris only some of the time, and not at all on Linux/GNU.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+tmp=tail-as2.$$
+pwd=`pwd`
+trap "cd $pwd; rm -rf $tmp" 0 1 2 3 15
+
+test_failure=0
+mkdir $tmp || test_failure=1
+cd $tmp || test_failure=1
+
+if test $test_failure = 1; then
+ echo 'failure in testing framework'
+ exit 1
+fi
+
+ok='ok ok ok'
+
+touch a
+tail --follow=name a foo > err 2>&1 &
+tail_pid=$!
+# Arrange for the tail process to die after 12 seconds.
+(sleep 12; kill $tail_pid) &
+echo $ok > f
+echo sleeping for 7 seconds...
+sleep 7
+mv f foo
+
+# echo waiting....
+wait
+
+case "`cat err`" in
+ *$ok) fail=0;;
+ *) fail=1;;
+esac
+
+test $fail = 1 && cat err
+
+exit $fail